       IDENTIFICATION DIVISION.
       PROGRAM-ID.  CUMEND.
       AUTHOR.      SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2015 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any non-commercial purpose and without fee is hereby      *
      * granted, provided the SimoTime copyright notice appear on all *
      * copies of the software. The SimoTime name or Logo may not be  *
      * used in any advertising or publicity pertaining to the use    *
      * of the software without the written permission of SimoTime    *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
      *
      * MAINTENANCE
      * -----------
      * 1989/02/27 Simmons, Created program.
      * 1997/03/17 Simmons, Updated for SYSID.
      *
      *****************************************************************
      *
       ENVIRONMENT DIVISION.

      *****************************************************************
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       01  VERSION-NUMBER       pic X(9)   value 'V01.00.00'.
       01  RECORD-LENGTH-512    pic S9(4)  comp    value 512.
       01  DATA-RESP-CODE       pic 9(08)  comp.
       01  NUMBER-WORK-16       pic 9(16)  value 0.
       01  CUSTOMER-READ-KEY    pic X(12).
       01  PF-ROW-23.
           05  filler           pic X(3)   value SPACES.
           05  PF-ROW-23-04     pic X(8)   value SPACES.
           05  PF-ROW-23-12     pic X(8)   value SPACES.
           05  PF-ROW-23-20     pic X(8)   value 'F3=Menu '.
           05  PF-ROW-23-28     pic X(8)   value SPACES.
           05  PF-ROW-23-36     pic X(8)   value SPACES.
           05  PF-ROW-23-44     pic X(8)   value SPACES.
           05  PF-ROW-23-52     pic X(8)   value SPACES.
           05  PF-ROW-23-60     pic X(8)   value SPACES.
           05  PF-ROW-23-68     pic X(8)   value 'F12=Esc '.
           05  filler           pic X(3)   value SPACES.

       01  EOJ-MESSAGE          pic X(50)
           value '     - Enter Tran ID . . .        completed CUMEND'.

       01  LGTH                 pic S9(4)  COMP.
       01  WORK-RESP-CODE       pic 9(08)  COMP.
       01  XCTL-RESP-CODE       pic 9(08)  COMP.

       01  X-EIB-MESSAGE.
           05  filler           pic X(8)   value 'EIBRESP='.
           05  X-EIB-RESP       pic 9(10)  value 0.
           05  filler           pic X(11)  value ', EIBRESP2='.
           05  X-EIB-RESP2      pic 9(10)  value 0.
           05  filler           pic X      value SPACE.
           05  X-EIB-USER-MSG   pic X(38)  value SPACES.

       01  PATCH-POS-CHAR.
           05  PATCH-POS        pic 9(5)   value ZERO.
       01  PATCH-LEN-CHAR.
           05  PATCH-LEN        pic 9(2)   value ZERO.
       01  PATCH-MODE           pic X      value SPACE.
       01  PATCH-DATA-CHAR      pic X(16)  value SPACES.

       01  CUSTOMER-KEY         pic X(12).
       01  MSG-LINES.
           03  MSG-DATA         pic X(78)  value LOW-VALUES.

       01  SYS-ID               pic X(4).

       01  WORK-DATE.
           05  WORK-DATE-CC     pic X(02).
           05  WORK-DATE-YY     pic 9(02).
           05  WORK-DATE-MM     pic X(02).
           05  WORK-DATE-DD     pic 9(02).
       01  WORK-TIME.
           05  WORK-TIME-HH     pic X(02).
           05  WORK-TIME-NN     pic X(02).
           05  WORK-TIME-SS     pic X(02).
           05  WORK-TIME-TT     pic X(02).

       01  WORK-08              pic X(8)   value SPACES.
       01  WORK-80              pic X(80)  value SPACES.
       01  WORK-POS-ALPHA.
           05  WORK-POS-VALUE   pic 9(8)   value 0.
       01  WORK-LEN-ALPHA.
           05  WORK-LEN-VALUE   pic 9(8)   value 0.
       01  DATA-LRECL-ALPHA.
           05  DATA-LRECL-VALUE pic 9(8)   value 512.
       01  BMS-POS-ALPHA.
           05  BMS-POS-VALUE    pic 9(8)   value 0.
       01  BMS-LEN-ALPHA.
           05  BMS-LEN-VALUE    pic 9(8)   value 0.

       01  W2-DATE              PIC S9(7)  COMP-3 value 0.
       01  W2-TIME              PIC S9(7)  COMP-3 value 0.

       01  Z-WORK-12            pic X(12)  value SPACES.
       01  IX-12                pic 9(3)   value 0.
       01  BF-1                 pic 9(3)   value 0.

       01  PROGRAM-NAME         pic x(8)   value SPACES.

       01  WS-RESPONSE         pic S9(8) comp.
       01  WS-REASON-CODE      pic S9(8) comp.

       01  LOCAL-TRAN-ID        pic X(4)   value 'CUM1'.

       01  PROGRAM-FLAGS.
           05  P-FLAG-ANIM      pic X      value 'N'.

          COPY CUMEND1.
          COPY DFHBMSCA.
          COPY DFHAID.
          COPY CUSTCB01.
          COPY PASSDUMP.

      *****************************************************************
       LINKAGE SECTION.
       01  DFHCOMMAREA.
           03  LS-CUSTNO         pic X(12).
           03  LS-REQPOS         pic X(8).
           03  filler            pic X(192).

      *****************************************************************
       PROCEDURE DIVISION.
      *    if  P-FLAG-ANIM = 'Y'
      *        CALL 'CBL_DEBUGBREAK'
      *    end-if.

           perform CLEAR-MESSAGES

           evaluate TRUE
             when EIBCALEN = ZERO
                  perform SEND-INQUIRY-SCREEN
             when EIBAID   = DFHPF3
                  perform END-OF-PROGRAM-03
             when EIBAID   = DFHPF9
                  perform UPDATE-CUSTOMER-INFORMATION
             when EIBAID   = DFHPF12
                  perform END-OF-PROGRAM-12
             when EIBAID   = DFHENTER
                  perform GET-CUSTOMER-INFORMATION
             when other
                  move 'Please use a valid customer number'
                  to MSG-LINES
                  perform RECOVERY-ROUTINE
           end-evaluate.
      *    Should never get to here...
           perform END-OF-PROGRAM-12.

      *****************************************************************
       BLANK-FILL-08.
           perform varying BF-1 from 1 by 1
                   until WORK-08(BF-1:1) not = ZERO
                   or BF-1 > 7
                   move SPACE to WORK-08(BF-1:1)
           end-perform
           exit.
      *****************************************************************
       BUILD-HEADER-INFO.
           EXEC CICS ASSIGN
                SYSID(SYS-ID)
                END-EXEC.

           move 'CUMEND1 ' to SYSPAGEO
           move SYS-ID to SYS-IDO.
           perform Z-GET-DATE-AND-TIME.
           perform Z-GET-DATE-AND-TIME-CICS.
           exit.

      *****************************************************************
       CLEAR-MESSAGES.
           move SPACES to MSG-LINES
           move SPACES to SYSMSG1O
           exit.

      *****************************************************************
       END-OF-PROGRAM-03.
           move 'MN1UTL  ' to PROGRAM-NAME
           perform TRANSFER-CONTROL
      *    Should never get to here...
           exit.

      *****************************************************************
       END-OF-PROGRAM-12.
           EXEC CICS SEND
                FROM   (EOJ-MESSAGE)
                LENGTH (50)
                ERASE
                END-EXEC

           EXEC CICS SEND
                CONTROL FREEKB
                END-EXEC

           EXEC CICS RETURN
                END-EXEC
           exit.

      *****************************************************************
       GET-CUSTOMER-INFORMATION.
           perform GET-CUSTOMER-NUMBER
           perform GET-CUSTOMER-RECORD
           move 'F9=Updt ' to PF-ROW-23-44
           perform SCREEN-IO-SEND-UPDATE
      *    Should never get to here...
           exit.

      *****************************************************************
       GET-CUSTOMER-NUMBER.
           EXEC CICS RECEIVE
                MAP    ('CUMEND1')
                MAPSET ('CUMEND1')
                RESP(WS-RESPONSE)
                RESP2(WS-REASON-CODE)
                END-EXEC.

           if  REQKEY1L > ZERO
               move REQKEY1I to Z-WORK-12
               perform Z-RIGHT-ADJUST-Z-WORK-12
               move Z-WORK-12 to REQKEY1I
               move REQKEY1I to LS-CUSTNO
           else
               move 'Please enter a 12 digit customer number...3'
                 to MSG-LINES
               perform RECOVERY-ROUTINE
           end-if.

           if  REQPOS1L > ZERO
               move SPACES to Z-WORK-12
               move REQPOS1I to Z-WORK-12
               perform Z-RIGHT-ADJUST-Z-WORK-12
               move Z-WORK-12(5:8) to WORK-POS-ALPHA
               move WORK-POS-ALPHA to REQPOS1I
               move REQPOS1I to LS-REQPOS
           else
               add 1 to ZERO giving WORK-POS-VALUE
               move WORK-POS-ALPHA to REQPOS1I
           end-if.

      *    Calculate length based on display of 256 and requested
      *    starting position.
           add 256 to ZERO giving WORK-LEN-VALUE
           if  WORK-POS-VALUE  > DATA-LRECL-VALUE
               move 'Record position exceeds Record Length'
                  to MSG-LINES(14:48)
                perform RECOVERY-ROUTINE
           else
               if  WORK-POS-VALUE + 256 > DATA-LRECL-VALUE
                   compute WORK-LEN-VALUE = DATA-LRECL-VALUE
                                          - WORK-POS-VALUE + 1
               end-if
           end-if
           exit.

      *****************************************************************
       GET-CUSTOMER-RECORD.
           move LS-CUSTNO to CUSTOMER-KEY.
           move 512       to LGTH.
           EXEC CICS read
                DATASET   ('CUSTMAST')
                INTO      (CUST-RECORD)
                LENGTH    (LGTH)
                RIDFLD    (CUSTOMER-KEY)
                KEYLENGTH (12)
                RESP      (WORK-RESP-CODE)
                END-EXEC.

      *    If the read worked the data is moved to the screen
      *
           if  WORK-RESP-CODE = ZEROS
               perform DATA-SCREEN-TO-FILE
           else
               move SPACES        to REQKEY1O
                                     SYSMSG1O
                move LS-CUSTNO to MSG-LINES
                move '* Customer number not found,please try again...'
                  to MSG-LINES(14:48)
                perform RECOVERY-ROUTINE
           end-if.

      *****************************************************************
       DATA-SCREEN-TO-FILE.
           move CUST-NUMBER      to REQKEY1O
           add 128 to ZERO giving SIMODUMP-LENGTH
           move 'NONE' to SIMODUMP-REQUEST
           move SPACES to SIMODUMP-BUFFER
           if  WORK-LEN-VALUE > 128
               move CUST-RECORD(WORK-POS-VALUE:128)
                 to SIMODUMP-BUFFER
           else
               move CUST-RECORD(WORK-POS-VALUE:WORK-LEN-VALUE)
                 to SIMODUMP-BUFFER
           end-if
           call 'SIMODUMP' using SIMODUMP-PASS-AREA SIMODUMP-BUFFER
           move WORK-POS-ALPHA to BMS-POS-ALPHA

           move SIMODUMP-LINES(1) to WORK-80
           move BMS-POS-ALPHA  to WORK-08
           perform BLANK-FILL-08
           move WORK-08        to LINE01I
      *    move BMS-POS-ALPHA  to LINE01I
           move WORK-80(11:8)  to HEX0101I
           move WORK-80(20:8)  to HEX0102I
           move WORK-80(29:8)  to HEX0103I
           move WORK-80(38:8)  to HEX0104I
           move WORK-80(47:16) to EBC01I
           move WORK-80(64:16) to ASC01I

           move SIMODUMP-LINES(2) to WORK-80
           add 16 to BMS-POS-VALUE
           move BMS-POS-ALPHA  to WORK-08
           perform BLANK-FILL-08
           move WORK-08        to LINE02I
      *    move BMS-POS-ALPHA  to LINE02I
           move WORK-80(11:8)  to HEX0201I
           move WORK-80(20:8)  to HEX0202I
           move WORK-80(29:8)  to HEX0203I
           move WORK-80(38:8)  to HEX0204I
           move WORK-80(47:16) to EBC02I
           move WORK-80(64:16) to ASC02I
           move LOW-VALUES    to SYSMSG1O

           move SIMODUMP-LINES(3) to WORK-80
           add 16 to BMS-POS-VALUE
           move BMS-POS-ALPHA  to WORK-08
           perform BLANK-FILL-08
           move WORK-08        to LINE03I
      *    move BMS-POS-ALPHA  to LINE03I
           move WORK-80(11:8)  to HEX0301I
           move WORK-80(20:8)  to HEX0302I
           move WORK-80(29:8)  to HEX0303I
           move WORK-80(38:8)  to HEX0304I
           move WORK-80(47:16) to EBC03I
           move WORK-80(64:16) to ASC03I

           move SIMODUMP-LINES(4) to WORK-80
           add 16 to BMS-POS-VALUE
           move BMS-POS-ALPHA  to WORK-08
           perform BLANK-FILL-08
           move WORK-08        to LINE04I
      *    move BMS-POS-ALPHA  to LINE04I
           move WORK-80(11:8)  to HEX0401I
           move WORK-80(20:8)  to HEX0402I
           move WORK-80(29:8)  to HEX0403I
           move WORK-80(38:8)  to HEX0404I
           move WORK-80(47:16) to EBC04I
           move WORK-80(64:16) to ASC04I

           move SIMODUMP-LINES(5) to WORK-80
           add 16 to BMS-POS-VALUE
           move BMS-POS-ALPHA  to WORK-08
           perform BLANK-FILL-08
           move WORK-08        to LINE05I
      *    move BMS-POS-ALPHA  to LINE05I
           move WORK-80(11:8)  to HEX0501I
           move WORK-80(20:8)  to HEX0502I
           move WORK-80(29:8)  to HEX0503I
           move WORK-80(38:8)  to HEX0504I
           move WORK-80(47:16) to EBC05I
           move WORK-80(64:16) to ASC05I

           move SIMODUMP-LINES(6) to WORK-80
           add 16 to BMS-POS-VALUE
           move BMS-POS-ALPHA  to WORK-08
           perform BLANK-FILL-08
           move WORK-08        to LINE06I
      *    move BMS-POS-ALPHA  to LINE06I
           move WORK-80(11:8)  to HEX0601I
           move WORK-80(20:8)  to HEX0602I
           move WORK-80(29:8)  to HEX0603I
           move WORK-80(38:8)  to HEX0604I
           move WORK-80(47:16) to EBC06I
           move WORK-80(64:16) to ASC06I

           move SIMODUMP-LINES(7) to WORK-80
           add 16 to BMS-POS-VALUE
           move BMS-POS-ALPHA  to WORK-08
           perform BLANK-FILL-08
           move WORK-08        to LINE07I
      *    move BMS-POS-ALPHA  to LINE07I
           move WORK-80(11:8)  to HEX0701I
           move WORK-80(20:8)  to HEX0702I
           move WORK-80(29:8)  to HEX0703I
           move WORK-80(38:8)  to HEX0704I
           move WORK-80(47:16) to EBC07I
           move WORK-80(64:16) to ASC07I

           move SIMODUMP-LINES(8) to WORK-80
           add 16 to BMS-POS-VALUE
           move BMS-POS-ALPHA  to WORK-08
           perform BLANK-FILL-08
           move WORK-08        to LINE08I
      *    move BMS-POS-ALPHA  to LINE08I
           move WORK-80(11:8)  to HEX0801I
           move WORK-80(20:8)  to HEX0802I
           move WORK-80(29:8)  to HEX0803I
           move WORK-80(38:8)  to HEX0804I
           move WORK-80(47:16) to EBC08I
           move WORK-80(64:16) to ASC08I

           move 'WORK-LEN-VALUE &&&&&&&&'
             to SYSMSG1O
           inspect SYSMSG1O replacing first '&&&&&&&&'
                                          by WORK-LEN-VALUE

           move SPACES to SIMODUMP-BUFFER
           if WORK-LEN-VALUE > 128
              subtract 128 from WORK-LEN-VALUE
           end-if
           if WORK-LEN-VALUE > 0
              move CUST-RECORD(WORK-POS-VALUE + 128:WORK-LEN-VALUE)
                to SIMODUMP-BUFFER
           end-if
           call 'SIMODUMP' using SIMODUMP-PASS-AREA SIMODUMP-BUFFER

           move SIMODUMP-LINES(1) to WORK-80
           add 16 to BMS-POS-VALUE
           move BMS-POS-ALPHA  to WORK-08
           perform BLANK-FILL-08
           move WORK-08        to LINE09I
      *    move BMS-POS-ALPHA  to LINE09I
           move WORK-80(11:8)  to HEX0901I
           move WORK-80(20:8)  to HEX0902I
           move WORK-80(29:8)  to HEX0903I
           move WORK-80(38:8)  to HEX0904I
           move WORK-80(47:16) to EBC09I
           move WORK-80(64:16) to ASC09I

           move SIMODUMP-LINES(2) to WORK-80
           add 16 to BMS-POS-VALUE
           move BMS-POS-ALPHA  to WORK-08
           perform BLANK-FILL-08
           move WORK-08        to LINE10I
      *    move BMS-POS-ALPHA  to LINE10I
           move WORK-80(11:8)  to HEX1001I
           move WORK-80(20:8)  to HEX1002I
           move WORK-80(29:8)  to HEX1003I
           move WORK-80(38:8)  to HEX1004I
           move WORK-80(47:16) to EBC10I
           move WORK-80(64:16) to ASC10I

           move SIMODUMP-LINES(3) to WORK-80
           add 16 to BMS-POS-VALUE
           move BMS-POS-ALPHA  to WORK-08
           perform BLANK-FILL-08
           move WORK-08        to LINE11I
      *    move BMS-POS-ALPHA  to LINE11I
           move WORK-80(11:8)  to HEX1101I
           move WORK-80(20:8)  to HEX1102I
           move WORK-80(29:8)  to HEX1103I
           move WORK-80(38:8)  to HEX1104I
           move WORK-80(47:16) to EBC11I
           move WORK-80(64:16) to ASC11I

           move SIMODUMP-LINES(4) to WORK-80
           add 16 to BMS-POS-VALUE
           move BMS-POS-ALPHA  to WORK-08
           perform BLANK-FILL-08
           move WORK-08        to LINE12I
      *    move BMS-POS-ALPHA  to LINE12I
           move WORK-80(11:8)  to HEX1201I
           move WORK-80(20:8)  to HEX1202I
           move WORK-80(29:8)  to HEX1203I
           move WORK-80(38:8)  to HEX1204I
           move WORK-80(47:16) to EBC12I
           move WORK-80(64:16) to ASC12I

           move SIMODUMP-LINES(5) to WORK-80
           add 16 to BMS-POS-VALUE
           move BMS-POS-ALPHA  to WORK-08
           perform BLANK-FILL-08
           move WORK-08        to LINE13I
      *    move BMS-POS-ALPHA  to LINE13I
           move WORK-80(11:8)  to HEX1301I
           move WORK-80(20:8)  to HEX1302I
           move WORK-80(29:8)  to HEX1303I
           move WORK-80(38:8)  to HEX1304I
           move WORK-80(47:16) to EBC13I
           move WORK-80(64:16) to ASC13I

           move SIMODUMP-LINES(6) to WORK-80
           add 16 to BMS-POS-VALUE
           move BMS-POS-ALPHA  to WORK-08
           perform BLANK-FILL-08
           move WORK-08        to LINE14I
      *    move BMS-POS-ALPHA  to LINE14I
           move WORK-80(11:8)  to HEX1401I
           move WORK-80(20:8)  to HEX1402I
           move WORK-80(29:8)  to HEX1403I
           move WORK-80(38:8)  to HEX1404I
           move WORK-80(47:16) to EBC14I
           move WORK-80(64:16) to ASC14I

           move SIMODUMP-LINES(7) to WORK-80
           add 16 to BMS-POS-VALUE
           move BMS-POS-ALPHA  to WORK-08
           perform BLANK-FILL-08
           move WORK-08        to LINE15I
      *    move BMS-POS-ALPHA  to LINE15I
           move WORK-80(11:8)  to HEX1501I
           move WORK-80(20:8)  to HEX1502I
           move WORK-80(29:8)  to HEX1503I
           move WORK-80(38:8)  to HEX1504I
           move WORK-80(47:16) to EBC15I
           move WORK-80(64:16) to ASC15I

           move SIMODUMP-LINES(8) to WORK-80
           add 16 to BMS-POS-VALUE
           move BMS-POS-ALPHA  to WORK-08
           perform BLANK-FILL-08
           move WORK-08        to LINE16I
      *    move BMS-POS-ALPHA  to LINE16I
           move WORK-80(11:8)  to HEX1601I
           move WORK-80(20:8)  to HEX1602I
           move WORK-80(29:8)  to HEX1603I
           move WORK-80(38:8)  to HEX1604I
           move WORK-80(47:16) to EBC16I
           move WORK-80(64:16) to ASC16I

      *    move LOW-VALUES    to SYSMSG1O

           exit.

      *****************************************************************
       RECOVERY-ROUTINE.
           move MSG-LINES to SYSMSG1O.
           move -1 to REQKEY1L
           perform SEND-INQUIRY-SCREEN
      *    Should never get to here...
           exit.

      *****************************************************************
       SEND-INQUIRY-SCREEN.
           perform BUILD-HEADER-INFO
           move PF-ROW-23 to PFROW23O

           EXEC CICS SEND
                MAP    ('CUMEND1')
                MAPSET ('CUMEND1')
                ERASE
                END-EXEC
           move LOW-VALUES to CUMEND1O
           EXEC CICS RETURN
                TRANSID (LOCAL-TRAN-ID)
                COMMAREA (CUMEND1O)
                LENGTH    (32)
                END-EXEC

      *    Should never get to here...
           exit.

      *****************************************************************
       SCREEN-IO-GET-DATA-FOR-UPDATE.
           EXEC CICS RECEIVE
                MAP    ('CUMEND1')
                MAPSET ('CUMEND1')
                END-EXEC.

           if  REQKEY1I > ZERO
               move REQKEY1I to Z-WORK-12
               perform Z-RIGHT-ADJUST-Z-WORK-12
               move Z-WORK-12 to REQKEY1I
               move REQKEY1I to LS-CUSTNO
           end-if.
           if  PATPOSI > ZERO
               move SPACES  to Z-WORK-12
               move PATPOSI to Z-WORK-12
               perform Z-RIGHT-ADJUST-Z-WORK-12
               move Z-WORK-12(8:5) to PATCH-POS-CHAR
           end-if.
           if  PATLENI > ZERO
               move SPACES  to Z-WORK-12
               move PATLENI to Z-WORK-12
               perform Z-RIGHT-ADJUST-Z-WORK-12
               move Z-WORK-12(11:2) to PATCH-LEN-CHAR
           end-if.

           move PATDATAI to PATCH-DATA-CHAR

           exit.

      *****************************************************************
       SCREEN-IO-SEND-UPDATE.
           perform BUILD-HEADER-INFO
           move PF-ROW-23 to PFROW23O
           EXEC CICS SEND
                MAP    ('CUMEND1')
                MAPSET ('CUMEND1')
                ERASE
                END-EXEC
           move LOW-VALUES to CUMEND1O
           EXEC CICS RETURN
                TRANSID (LOCAL-TRAN-ID)
                COMMAREA (CUMEND1O)
                LENGTH    (4096)
                END-EXEC

      *    Should never get to here...
           exit.

      *****************************************************************
       TRANSFER-CONTROL.
           EXEC CICS XCTL
                PROGRAM(PROGRAM-NAME)
                RESP(XCTL-RESP-CODE)
                END-EXEC

      *    Should never get to here...
           move 'Program not found, &&&&&&&&' to MSG-LINES.
           inspect MSG-LINES replacing first '&&&&&&&&'
                                          by PROGRAM-NAME
           move -1 to REQKEY1L.
           perform RECOVERY-ROUTINE.
      *    exit.

      *****************************************************************
       GENERAL-ERROR-ROUTINE.
           move '                         General Error'
             to X-EIB-USER-MSG
           add EIBRESP  to ZERO giving X-EIB-RESP
           add EIBRESP2 to ZERO giving X-EIB-RESP2
           move X-EIB-MESSAGE to MSG-LINES.
           perform RECOVERY-ROUTINE
      *    Should never get to here...
           exit.

      *****************************************************************
       UPDATE-CUSTOMER-INFORMATION.
           perform SCREEN-IO-GET-DATA-FOR-UPDATE

      *    if  CUTOKENI = 999
      *        perform UPDATE-CUSTOMER-INFORMATION-02
      *    else
               perform UPDATE-CUSTOMER-INFORMATION-01
      *    end-if
           exit.

      *****************************************************************
       UPDATE-CUSTOMER-INFORMATION-01.
      *    Attempt to update an existing record
           move REQKEY1I to CUSTOMER-READ-KEY
           perform  CUSTMAST-READ-UPDATE

           if  DATA-RESP-CODE not = 0
               add DATA-RESP-CODE to ZERO giving NUMBER-WORK-16
               move 'ReRead Failed,  ' to MSG-LINES(1:16)
               move REQKEY1I           to MSG-LINES(16:12)
               move CUST-NUMBER        to MSG-LINES(30:12)
               move VERSION-NUMBER     to MSG-LINES(70:9)
               perform GENERAL-ERROR-ROUTINE
           end-if.

      *    perform DATA-SCREEN-TO-FILE
           perform Z-GET-DATE-AND-TIME
      *    move WORK-DATE to CUST-LADATE
      *    move WORK-TIME to CUST-LATIME
      *    move ZEROES to CUST-TOKEN

           move PATCH-DATA-CHAR to CUST-RECORD(PATCH-POS:PATCH-LEN)

           perform CUSTMAST-REWRITE

           if  DATA-RESP-CODE = 0
               move
               'Update Completed, type new request and press ENTER key'
               to MSG-LINES(1:54)
               move MSG-LINES to SYSMSG1O
               move '        ' to PF-ROW-23-44
               perform SCREEN-IO-SEND-UPDATE
           else
               add DATA-RESP-CODE to ZERO giving NUMBER-WORK-16
               move 'Update Failed,  ' to MSG-LINES(1:16)
               move REQKEY1I           to MSG-LINES(16:12)
               move CUST-NUMBER        to MSG-LINES(30:12)
               move VERSION-NUMBER     to MSG-LINES(70:9)
               perform GENERAL-ERROR-ROUTINE
           end-if.

      *    Should never get to here...
           exit.

      *****************************************************************
       UPDATE-CUSTOMER-INFORMATION-02.
      *    Attempt to add a new record
           move REQKEY1I to CUSTOMER-READ-KEY
           perform DATA-SCREEN-TO-FILE

           perform Z-GET-DATE-AND-TIME
           move WORK-DATE to CUST-LADATE
           move WORK-TIME to CUST-LATIME
           move ZEROES to CUST-TOKEN

           perform CUSTMAST-WRITE

           if  DATA-RESP-CODE = 0
               move
               'Write Completed, type new request and press ENTER key '
               to MSG-LINES(1:54)
               move MSG-LINES to SYSMSG1O
               move '        ' to PFROW23O
               perform SCREEN-IO-SEND-UPDATE
           else
               add DATA-RESP-CODE to ZERO giving NUMBER-WORK-16
               move 'Write Failed,   ' to MSG-LINES(1:16)
               move REQKEY1I           to MSG-LINES(16:12)
               move CUST-NUMBER        to MSG-LINES(30:12)
               move VERSION-NUMBER     to MSG-LINES(70:9)
               perform GENERAL-ERROR-ROUTINE
           end-if.

      *    Should never get to here...
           exit.

      *****************************************************************
       CUSTMAST-READ.
           move LS-CUSTNO to CUSTOMER-READ-KEY.
           EXEC CICS READ
                DATASET   ('CUSTMAST')
                INTO      (CUST-RECORD)
                LENGTH    (RECORD-LENGTH-512)
                RIDFLD    (CUSTOMER-READ-KEY)
                KEYLENGTH (12)
                RESP      (DATA-RESP-CODE)
                END-EXEC.
           exit.

      *****************************************************************
       CUSTMAST-READ-UPDATE.
           EXEC CICS READ
                DATASET   ('CUSTMAST')
                INTO      (CUST-RECORD)
                LENGTH    (RECORD-LENGTH-512)
                RIDFLD    (CUSTOMER-READ-KEY)
                KEYLENGTH (12)
                UPDATE
                RESP      (DATA-RESP-CODE)
                END-EXEC.
           exit.

      *****************************************************************
       CUSTMAST-REWRITE.
           EXEC CICS REWRITE
                DATASET   ('CUSTMAST')
                FROM      (CUST-RECORD)
                LENGTH    (RECORD-LENGTH-512)
                RESP      (DATA-RESP-CODE)
                END-EXEC.
           exit.

      *****************************************************************
       CUSTMAST-WRITE.
           EXEC CICS WRITE
                DATASET   ('CUSTMAST')
                FROM      (CUST-RECORD)
                LENGTH    (RECORD-LENGTH-512)
                RIDFLD    (CUSTOMER-READ-KEY)
                RESP      (DATA-RESP-CODE)
                END-EXEC.
           exit.

      *****************************************************************
      * Delete all characters to the right of the first space then
      * right-adjust with zero fill. This routine works with a single,
      * twelve character field and does not require a work area.
      *****************************************************************
       Z-RIGHT-ADJUST-Z-WORK-12.
           inspect Z-WORK-12
                   replacing CHARACTERS by ' ' after initial ' '
           perform until Z-WORK-12(12:1) not = SPACE
               if  Z-WORK-12(12:1) = SPACE
                   add 11 to ZERO giving IX-12
                   perform 11 times
                     move Z-WORK-12(IX-12:1) to Z-WORK-12(IX-12 + 1:1)
                     subtract 1 from IX-12
                   end-perform
                   move ZERO to Z-WORK-12(1:1)
               end-if
           end-perform
           exit.

      *****************************************************************
       Z-GET-DATE-AND-TIME.
           accept WORK-DATE from DATE YYYYMMDD
           accept WORK-TIME from TIME

           move 'ccyy/mm/dd'   to SYSDATEO
           move WORK-DATE(1:4) to SYSDATEO(1:4)
           move WORK-DATE(5:2) to SYSDATEO(6:2)
           move WORK-DATE(7:2) to SYSDATEO(9:2)

           move 'hh:mm:ss:dd'  to SYSTIMEO
           move WORK-TIME(1:2) to SYSTIMEO(1:2)
           move WORK-TIME(3:2) to SYSTIMEO(4:2)
           move WORK-TIME(5:2) to SYSTIMEO(7:2)
           move WORK-TIME(7:2) to SYSTIMEO(10:2)

           exit.

      *****************************************************************
       Z-GET-DATE-AND-TIME-CICS.
           EXEC CICS ASKTIME END-EXEC
           MOVE EIBDATE TO W2-DATE
           MOVE EIBTIME TO W2-TIME
           exit.
